/* global BDF,$$,Multi */

Multi.List = {};

Multi.List.init = function() {
    Multi.List.loadAjax(function (fichothequeArray) {
        Multi.fichothequeArray = fichothequeArray;
        $$("listpane_fichothequelist").html(BDF.render("multi:nav-fichotheque", fichothequeArray));
        Multi.List.initActions();
    });
    
};

Multi.List.initActions = function() {
    var $fichothequeList = $$("listpane_fichothequelist");
    BDF.onClick($fichothequeList, {action: "duplicate"}, function () {
        Multi.Overlay.showDuplicationForm(BDF.Pane.getEntryName(this));
    });
    BDF.onClick($fichothequeList, {action: "init"}, function () {
        Multi.List.initFichotheque(BDF.Pane.getEntryName(this));
    });
    
    
};

Multi.List.reload = function () {
    Multi.List.loadAjax(Multi.List.update);
};

Multi.List.initAll = function () {
    var notInitArray = new Array();
    var currentIndex = 0;
    for(let fichotheque of Multi.fichothequeArray) {
        if (!fichotheque.init) {
            notInitArray.push(fichotheque);
        }
    }
    _initNext();
    
    
    function _initNext() {
        if (currentIndex < notInitArray.length) {
            let nextFichotheque = notInitArray[currentIndex];
            currentIndex++;
            Multi.List.initFichotheque(nextFichotheque.name, _initNext);
        }
    }
    
};

Multi.List.initFichotheque = function (fichothequeName, callback) {
    $.ajax({
            url: BDF.URL,
            data: {
                json: "fichotheque-array",
                cmd: "FichothequeInit",
                name: fichothequeName
            },
            dataType: BDF.jsonDataType,
            success: function (data, textStatus) {
                if (Multi.testAuthentification(data)) {
                    BDF.Ajax.success(data, "fichothequeArray", function (fichothequeArray) {
                        Multi.List.update(fichothequeArray);
                        if (callback) {
                            callback();
                        }
                    });
                }
            }
        });
};

Multi.List.loadAjax = function (callback) {
    $.ajax({
        url: BDF.URL,
        data: {
            json: "fichotheque-array"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            if (Multi.testAuthentification(data)) {
                BDF.Ajax.success(data, "fichothequeArray", callback);
            }
        }
    });
};

Multi.List.update = function (fichothequeArray) {
    Multi.fichothequeArray = fichothequeArray;
    var $fichothequeList = $$("listpane_fichothequelist");
    var $currentLis = $fichothequeList.children("div");
    var newLength = fichothequeArray.length;
    if (newLength === 0) {
        $fichothequeList.empty();
        return;
    }
    var currentLength = $currentLis.length;
    var p = 0;
    for(let newFichotheque of fichothequeArray) {
        while(true) {
            if (p >= currentLength) {
                $fichothequeList.append(BDF.render("multi:nav-fichotheque", newFichotheque));
                break;
            } else {
                var $currentFichotheque = $($currentLis[p]);
                var currentFichothequeName = $currentFichotheque.data("name");
                if (newFichotheque.name === $currentFichotheque) {
                    $currentFichotheque.replaceWith(BDF.render("multi:nav-fichotheque", newFichotheque));
                        p++;
                    break;
                } else if (newFichotheque.name < currentFichothequeName) {
                    $currentFichotheque.before(BDF.render("multi:nav-fichotheque", newFichotheque));
                    break;
                } else {
                    $currentFichotheque.remove();
                    p++;
                }
            }
        }
    }
};
